<?php
/**
 * @author  RadiusTheme
 * @since   1.0
 * @version 1.0
 */

namespace radiustheme\Barta_Core;

use BartaTheme;
use BartaTheme_Helper;

use \WP_Query;

$thumb_size = 'barta-size5';

/*query process*/ 
// category
$category = $data['cat_post_grid'];
// number
$number_of_post = $data['number_of_post'];
$number_of_post_offset = $data['number_of_post_offset'];
$p_ids = array();

// build up the array
foreach ( $data['posts_not_in'] as $p_idsn ) {
	$p_ids[] = $p_idsn['post_not_in'];
}
// sort
$post_sorting = $data['post_sorting'];
// order
$post_ordering = $data['post_ordering'];
// Title Limit
$title_limit = $data['post_title_length'];
// Title Limit
$content_limit = $data['post_excerpt_length'];

$class = $data['slider_nav'] == 'yes' ? ' slider-nav-enabled' : '';
?>
<div class="default-slider <?php echo esc_attr( $template ); ?>">
	<?php if ( $data['has_sec_title'] == 'yes' ) { ?>
	<div class="mb-25p">
		<div class="rt-news-box-title-holder <?php echo esc_attr( $data['title_style'] ); ?>">
			<h2 class="el-rt-news-box-title <?php echo esc_attr( $data['title_style'] ); ?>"><?php echo esc_html( $data['title'] ); ?><span class="titleinner"></span></h2>
		</div>
	</div>
	<?php } ?>
	<div class="rt-el-post-slider owl-wrap rt-owl-nav rt-owl-dot<?php echo esc_attr( $class );?>">
	<div class="owl-theme owl-carousel rt-owl-carousel" data-carousel-options="<?php echo esc_attr( $data['owl_data'] ); ?>">	
		<?php
			if ( $data['cat_num'] == 'multi' ) {
			// build up the array
			foreach ( $data['category_list'] as $cat ) {
				$cats[] = array(
					'cat_multi_box' => $cat['cat_multi_box'],
				);
			}
			if ( !empty( $cats ) ) {
				//category
				$category_number = count( $cats );
				foreach ( $cats as $cat ) {
					if ( $cat['cat_multi_box'] != 0 ) {
					
					$args = array(
						'cat' => $cat['cat_multi_box'],
						'order' => $post_ordering,
						'posts_per_page' => $data['number_of_post'],
						'offset' 	 	 => $number_of_post_offset,
						'post__not_in'   => $p_ids
					);
						
					if ( $post_sorting == 'view' ) {
						$args['orderby']  = 'meta_value_num';
						$args['meta_key'] = 'barta_views';
					} else {
						$args['orderby'] = $post_sorting;
					}
					$query = new WP_Query( $args );
					$temp = BartaTheme_Helper::wp_set_temp_query( $query );
		?>
		<?php if ( $query->have_posts() ) { ?>
			<?php while ( $query->have_posts() ) { $query->the_post();
				$news_title = wp_trim_words(get_the_title(), $title_limit, '');
				$excerpt = wp_trim_words(get_the_excerpt(), $content_limit, '');
				$news_comment_num = number_format_i18n( get_comments_number() );
				if ( !empty( $data['post_date_format'] ) ) {
					if ( $data['post_date_format'] == 'global' ){
						$formatted_post_date = get_the_date(); 
					} else {
						$formatted_post_date = get_the_date( 'M d, Y' );
					}
				}
			?>
			<div class="rtin-item">
				<div class="hover-show-play-btn">
					<div class="img-overlay-70">
						<?php if ( $data['show_post_thumb'] == 'yes' ) { ?>
							<a href="<?php the_permalink(); ?>" class="img-opacity-hover img-overlay-70">
							<?php
								if ( has_post_thumbnail() ){
									the_post_thumbnail( $thumb_size, ['class' => 'img-fluid mb-10 width-100'] );
								} else {
									if ( $data['show_no_preview_img'] == 'yes') {
									
										if ( !empty( BartaTheme::$options['no_preview_image']['id'] ) ) {
											echo wp_get_attachment_image( BartaTheme::$options['no_preview_image']['id'], $thumb_size );
										} else {
											echo '<img class="wp-post-image" src="' . BartaTheme_Helper::get_img( 'noimage-555x370.jpg' ) . '" alt="'.get_the_title().'">';
										}
									}
								}
							?>
							</a>
							<?php if ( $data['cat_display'] == 'yes' ) { echo barta_sel_category_prepare( $cat['cat_multi_box'] ); } ?>
						<?php } ?>
						<?php if ( get_post_format( get_the_ID() ) == 'video' ) { ?>
						<div class="video-icon">
							<a href="<?php the_permalink(); ?>"><img src="<?php echo esc_attr( BartaTheme_Helper::get_img( 'play.png' ) ); ?>" alt="play" class="img-fluid"></a>
						</div>
						<?php } ?>
					</div>
					<div class="video-content">
						<div class="post-meta-light">
							<ul>
								<?php if ( $data['post_author'] == 'yes') { ?>
									<li><span><i class="fa fa-user" aria-hidden="true"></i></span><?php the_author_posts_link(); ?></li>
								<?php } ?>
								<?php if ( $data['post_date'] == 'yes' ) { ?>
									<li><span><i class="fa fa-clock-o" aria-hidden="true"></i></span><?php echo $formatted_post_date; ?></li>
								<?php } ?>
								<?php if ( $data['post_comment'] == 'yes' ) { ?>
									<li><span><i class="fa fa-comment-o" aria-hidden="true"></i></span><a href="<?php echo get_comments_link( get_the_ID() ); ?>"> <?php echo esc_html( $news_comment_num );?></a></li>
								<?php } ?>
							</ul>
						</div>
						<h3 class="title-medium-dark">
							<a href="<?php the_permalink(); ?>"><?php echo esc_html( $news_title ); ?></a>
						</h3>
					</div>
				</div>
			</div>
			<?php } ?>
		<?php } BartaTheme_Helper::wp_reset_temp_query( $temp );
				}
			}
		}
	} else {
		
		$args = array(
			'cat' => (int) $data['cat_post_grid'],
			'post_status' => 'publish',
			'order' => $post_ordering,
			'posts_per_page' => $number_of_post,
			'offset' 	 	 => $number_of_post_offset,
			'post__not_in'   => $p_ids
		);
			
		if ( $post_sorting == 'view' ) {
			$args['orderby']  = 'meta_value_num';
			$args['meta_key'] = 'barta_views';
		} else {
			$args['orderby'] = $post_sorting;
		}
					
		$query = new WP_Query( $args );
		$temp = BartaTheme_Helper::wp_set_temp_query( $query );
		?>		
			<?php if ( $query->have_posts() ) { ?>
				<?php while ( $query->have_posts() ) { $query->the_post();					
					$excerpt = wp_trim_words(get_the_excerpt(), $content_limit, '');
					$news_title = wp_trim_words(get_the_title(), $title_limit, '');
					$news_comment_num = number_format_i18n( get_comments_number() );
					if ( !empty( $data['post_date_format'] ) ) {
						if ( $data['post_date_format'] == 'global' ){
							$formatted_post_date = get_the_date(); 
						} else {
							$formatted_post_date = get_the_date( 'M d, Y' );
						}
					}
				?>
				<div class="rtin-item">
					<div class="hover-show-play-btn">
						<div class="img-overlay-70">
							<?php if ( $data['show_post_thumb'] == 'yes' ) { ?>
								<a href="<?php the_permalink(); ?>" class="img-opacity-hover img-overlay-70">
									<?php
										if ( has_post_thumbnail() ){
											the_post_thumbnail( $thumb_size, ['class' => 'img-fluid mb-10 width-100'] );
										} else {
											if ( $data['show_no_preview_img'] == 'yes') {
											
												if ( !empty( BartaTheme::$options['no_preview_image']['id'] ) ) {
													echo wp_get_attachment_image( BartaTheme::$options['no_preview_image']['id'], $thumb_size );
												} else {
													echo '<img class="wp-post-image" src="' . BartaTheme_Helper::get_img( 'noimage-555x370.jpg' ) . '" alt="'.get_the_title().'">';
												}
											}
										}
									?>
								</a>
								<?php if ( $data['cat_display'] == 'yes' ) { echo barta_sel_category_prepare( $data['cat_post_grid'] ); } ?>
							<?php } ?>
							<?php if ( get_post_format( get_the_ID() ) == 'video' ) { ?>
							<div class="video-icon">
								<a href="<?php the_permalink(); ?>"><img src="<?php echo esc_attr( BartaTheme_Helper::get_img( 'play.png' ) ); ?>" alt="play" class="img-fluid"></a>
							</div>
							<?php } ?>
						</div>
						<div class="video-content">
							<div class="post-meta-light">
								<ul>
									<?php if ( $data['post_author'] == 'yes') { ?>
										<li><span><i class="fa fa-user" aria-hidden="true"></i></span><?php the_author_posts_link(); ?></li>
									<?php } ?>
									<?php if ( $data['post_date'] == 'yes' ) { ?>
										<li><span><i class="fa fa-clock-o" aria-hidden="true"></i></span><?php echo $formatted_post_date; ?></li>
									<?php } ?>
									<?php if ( $data['post_comment'] == 'yes' ) { ?>
										<li><span><i class="fa fa-comment-o" aria-hidden="true"></i></span><a href="<?php echo get_comments_link( get_the_ID() ); ?>"> <?php echo esc_html( $news_comment_num );?></a></li>
									<?php } ?>
								</ul>
							</div>
							<h3 class="title-medium-dark">
								<a href="<?php the_permalink(); ?>"><?php echo esc_html( $news_title ); ?></a>
							</h3>
						</div>
					</div>
				</div>
				<?php } ?>
			<?php } ?>
		<?php } ?>			
		<?php BartaTheme_Helper::wp_reset_temp_query( $temp );?>
		</div>
	</div>
</div>